#ifndef bspline_interp_H
#define bspline_interp_H

/* B-spline smoothing of equally-spaced numerical series. */
/* Last edited on 2012-03-04 19:56:16 by stolfilocal */ 

#include <bool.h>
#include <indexing.h>

int interp_spline_B_compute_num_samples(int order);
  /* Computes the number of samples {m} needed along each axis for
    interpolation of the specified {order}. */

void interp_spline_B_get_weights(double t, int order, int m, double w[]);
  /* Computes the weights {w[0..m-1]} of the {m} pixels needed to
    perform spline interpolation defined by {order} and [convex}
    in a sequence of samples at the fractional
    coordinate {t}. The size {m} of {w} must be correct for
    the given {order}. */

#endif
