#ifndef ispline_interp_H
#define ispline_interp_H

/* Spline interpolation of equally-spaced numerical series. */
/* Last edited on 2012-03-04 19:57:26 by stolfilocal */ 

#include <bool.h>
#include <indexing.h>

int interp_spline_I_compute_num_samples(int order);
  /* Computes the number of samples {m} needed along each axis for
    interpolation of the specified {order}. */

void interp_spline_I_get_weights(double t, int order, int m, double w[]);
  /* Computes the weights {w[0..m-1]} of the {m} pixels needed to
    perform I-spline interpolation of the given {order} 
    in a sequence of samples at the fractional coordinate {t}. */

#endif
