#ifndef ospline_interp_H
#define ospline_interp_H

/* Spline interpolation of equally-spaced numerical series. */
/* Last edited on 2012-03-04 19:56:40 by stolfilocal */ 

#include <bool.h>
#include <indexing.h>

int interp_spline_O_compute_num_samples(int order);
  /* Computes the number of samples {m} needed along each axis for
    interpolation of the specified {order}. */

void interp_spline_O_get_weights(double t, int order, int m, double w[]);
  /* Computes the indices {i[0..m-1]} of the {m} pixels needed to
    perform B-spline interpolation in a sequence of samples at the fractional
    coordinate {t}, and their respective presence weights {w[0..m-1]}. Indices {i}
    outside the range {0..N-1} are reduced according to {ix_reduce(i, N,
    red)}.  Some reduced indices may be {-1} to denote `no such pixel'. */

#endif
